<template>

  <Head>
    <title>Products - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow">
              <!-- text header -->
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-shopping-bag me-2"></i> PRODUCTS</span>
              </div>
              <div class="card-body">
                <div class="row">
                  <!-- link to view create product -->
                  <div class="col-md-6">
                    <Link href="/apps/products/create" v-if="hasAnyPermission(['products.create'])"
                      class="btn btn-primary input-group-text"><i class="fa fa-plus-circle me-2"></i> Create Product
                    </Link>
                  </div>
                  <!-- form search products -->
                  <div class="col-md-6">
                    <form @submit.prevent="handleSearch">
                      <div class="input-group mb-3">
                        <input type="text" class="form-control" placeholder="Search Product..." v-model="search">
                        <button class="btn btn-primary input-group-text" type="submit">
                          <i class="fa fa-search me-2"></i>
                        </button>
                      </div>
                    </form>
                  </div>
                </div>
                <!-- table of products -->
                <div class="table-responsive">
                  <table class="table table-hover">
                    <thead class="bg-primary text-white">
                      <tr>
                        <th scope="col">#</th>
                        <th scope="col">Barcode</th>
                        <th scope="col">Product Name</th>
                        <th scope="col">Image</th>
                        <th scope="col">Buy Price</th>
                        <th scope="col">Sell Price</th>
                        <th scope="col">Stock</th>
                        <th scope="col" style="width:15%">Actions</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(product, index) in products.data" :key="index">
                        <td class="fw-bold text-center">
                          {{ ++index + (products.current_page - 1) *
                          products.per_page }}
                        </td>
                        <td class="text-center">
                            <Barcode :value="product.barcode" :format="'CODE39'" :lineColor="'#000'" :width="1" :height="20" />
                        </td>
                        <td >
                          <span v-if="product.name.length < 29">{{ product.name }}</span>
                          <span v-else>{{ product.name.substring(0,30)+"..." }}</span>
                        </td>
                        <td><img :src="product.image" style="width: 85px"></td>
                        <td>Rp {{ formatPrice(product.buy_price) }}</td>
                        <td>Rp {{ formatPrice(product.sell_price) }}</td>
                        <td>{{ product.stock }}</td>
                        <td class="text-center">
                          <!-- link view edit -->
                          <Link :href="`/apps/products/${product.slug}/edit`" v-if="hasAnyPermission(['products.edit'])"
                            class="btn btn-info btn-sm mb-md-0 mx-1 mb-2 mb-sm-0"><i
                            class="fa fa-pencil-alt text-white fa-fw"></i>
                          </Link>
                          <!-- button delete -->
                          <button @click.prevent="destroy(product.slug)" v-if="hasAnyPermission(['products.delete'])"
                            class="btn btn-danger btn-sm mx-1"><i class="fa fa-trash fa-fw"></i>
                          </button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
                <!-- pagination -->
                <Pagination :links="products.links" align="end" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue'

// import component pagination
import Pagination from '../../../Components/Pagination.vue'

// import Heade and Link from Inertia
import { Head, Link } from '@inertiajs/vue3'

// import ref from vue
import { ref } from 'vue'

// import inertia adapter
import { router } from '@inertiajs/vue3'

// import sweetalert2
import Swal from 'sweetalert2'

// import jsbarcode 
import Barcode from '../../../Components/Barcode.vue'

export default {
  // layout
  layout: LayoutApp,

  // register components
  components: {
    Head,
    Link,
    Pagination,
    Barcode,
  },

  // props
  props: {
    products: Object,
  },

  setup() {
    // define state search
    const search = ref('' || (new URL(document.location)).searchParams.get('q'));

    // define method search
    const handleSearch = () => {
      router.get('/apps/products', {

        // send params "q" with value from state "search"
        q: search.value,
      });
    }

    // define method destroy
    const destroy = (slug) => {
      Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
      })
        .then((result) => {
          if (result.isConfirmed) {
            router.delete(`/apps/products/${slug}`);
            Swal.fire({
              title: 'Deleted!',
              text: 'Product has been deleted.',
              icon: 'success',
              timer: 2000,
              showConfirmButton: false,
            });
          }
        })
    }

    // return
    return {
      search,
      handleSearch,
      destroy
    }
  }
}
</script>

<style scoped>
th, td {
  text-align: center;
}
</style>